#!/usr/bin/env node

var log = require('color-log'),
    _ = require('underscore'),
    commander = require('commander');

var modules = require('../lib/search-start-module'),
    moduleDepend = require('../lib/search-module-dependencies');

commander
    .version('0.1.0')
    .option('-d, --debug', '生成debug版本')
    .option('-n, --notcombo', 'html页面主模块恢复为默认');

commander.on('--help', function() {
    console.log('  Examples:');
    console.log('');
    console.log('  $ js-combo');
    console.log('  $ js-combo -d');
    console.log('');
});

commander.parse(process.argv);

function main() {

    modules.getModules(function(m) {

        var options = {};
        var htmlOptions = {};

        if (commander.notcombo) {
            htmlOptions.notcombo = true;
        }
        if (commander.debug) {
            htmlOptions.debug = 'debug';
            options.debug = 'debug';
        }

        moduleDepend.dependencies(['dialog'], options, masterModuleDependComboFinish);

        modules.startModuleReplaceCombo(htmlOptions, startModuleReplaceComboFinish);
    });
}

function masterModuleDependComboFinish(moduleName){
    log.info();
    log.info(moduleName + ': 所有依赖打包合并已完成');
}

function startModuleReplaceComboFinish() {
    log.info();
    log.info('html主模块替换combo模块已完成');
}

main();