var fs = require('fs'),
    path = require('path');

var log = require('color-log');

var config = require('./config');

var currentPath = process.cwd(),
    rootHtmlPath = '',
    modules = [],
    moduleHtml = {},
    comboFileExt = '-combo',
    count = 0;

exports.getModules = function(callback) {

    config.getConfig(function(data) {

        rootHtmlPath = path.join(currentPath, data.htmlSrc);

        fs.stat(rootHtmlPath, function(err, stats) {

            if (stats.isDirectory()) {

                fs.readdir(rootHtmlPath, function(err, files) {

                    files.forEach(function(v, k) {

                        if (path.extname(v) === '.html') {

                            getModule(path.join(rootHtmlPath, v), v, files.length, callback);
                        }
                    });
                });
            }
        });
    });
}

function getModule(htmlFile, filename, length, callback) {

    fs.readFile(htmlFile, function(err, data) {

        if (err) {
            log.error('读取出错：' + htmlFile);
            process.exit(1);
        } else {

            var r = /use\s*\(\s*\[\s*'(.*?)'/i;
            var html = data.toString();
            var module = html.match(r)[1];

            modules.push(module);
            moduleHtml[module] = {
                filename: filename,
                html: html
            };

            if (count === length - 1) {
                callback(modules);
            }
            count++;
        }
    });
}

exports.startModuleReplaceCombo = function(options, finish) {

    comboFileExt = options.debug ? comboFileExt + '-' + options.debug : comboFileExt;

    replaceCombo(options, writeHtmlFile, finish);
}

var module_reg = /use\s*\(\s*\[\s*'(.*?)'/i;
var combo_reg = /-combo'$/i;
var combo_debug_reg = /-combo-debug'$/i;
// var reg = /id="seajsnode"*\ssrc=".*&(config.*?js)|(seajs-helper.*?js)&.*">/i;

function replaceCombo(options, callback, finish) {

    (function next(i) {

        if (i < modules.length) {

            moduleHtml[modules[i]].html = moduleHtml[modules[i]].html.replace(module_reg, function(w) {

                if (options.notcombo) {
                    if (combo_debug_reg.test(w)) {
                        return w.replace(combo_debug_reg, '\'');
                    } else if(combo_reg.test(w)){
                        return w.replace(combo_reg, '\'');
                    }
                } else {
                    if (combo_debug_reg.test(w) || combo_reg.test(w)) {
                        return w;
                    } else {
                        return w.replace(modules[i], modules[i] + comboFileExt);
                    }
                }
            });

            callback(moduleHtml[modules[i]], function() {
                next(i + 1);
            });
        } else {
            finish && finish();
        }
    }(0));
}

function writeHtmlFile(data, callback) {

    var pathname = path.join(rootHtmlPath, data.filename);

    fs.writeFile(pathname, data.html, function(err) {

        if (err) {
            log.error(data.filename + ': html重写失败');
        } else {
            callback();
        }
    });
}